<?php
/**
* リソースを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_ResourceFactory
{
	/*
	 * リソースを作成
	 */
	public static function create( $resource_name )
	{
		log_info( 'system', "リソース[$resource_name]をロードします。", __FILE__, __LINE__ );

		// リソース設定ファイルの読み込み
		$config = charcoal_ConfigLoader::loadConfig( $resource_name, 'resource' );

		// クラス名を取得
		$class_name = $config->getString( 'class_name' );

		// リソースのインスタンス生成
		$resource = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIResourceインタフェースを実装しているか確認
		if ( !($resource instanceof charcoal_IResource) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_IResource" );
		}

		log_info( 'system',  "リソース[$resource_name]を初期化します。", __FILE__, __LINE__ );

		// リソースを初期化
		$resource->init( $config );

		log_info( 'system', "リソース[$resource_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたリソースを返却
		return $resource;
	}
}
